/*
Example user code that calls the "oslevent" library
to control the execution of two simple processes "A" and "B".

Orion Sky Lawlor, olawlor@acm.org, 2005/1/28 (Public Domain)
*/
#include <stdio.h> /* for printf */
#include "oslevent.h"
oslevent_pool *oslevent; /* library interface object (doesn't have to be global) */

class sequencer : public oslevent_class {
public:
	const char *what; /* what we're doing */
	int s, n; /* current step, and number of steps */
	sequencer(const char *what_,int n_) {what=what_; s=0; n=n_;}

	virtual void execute(void) {
		s++;
		
		for (int i=0;i<1000*1000;i++) {}
		printf("%s (%d)\n",what,s); /* or real code here... */
		
		if (s<n) oslevent->add(this); /* ask for another execution */
	}
};

int main() {
	oslevent=new oslevent_pool; /* initialize library */
	sequencer s1("A",20), s2("      B",20);
	oslevent->add(&s1); /* will run s1.execute() once during loop */
	oslevent->add(&s2); /* will run s2.execute() once during loop */
	oslevent->loop(); /* keep processing events until there are no more */
}
